;;;; utf8-string-interpolator.scm  -*- Scheme -*-
;;;; Kon Lovett, Aug '19

(declare
  (bound-to-procedure ##sys#print-to-string))

(module utf8-string-interpolator

(;export
  string-interpolate
  string-interpolate/sanity)

(import (except scheme read-char #;peek-char #;read)
  (chicken base)
  (chicken platform)
  (chicken type)
  (only (srfi 1) reverse!)
  (only utf8 read-char list->string)
  (only utf8-srfi-13 string-concatenate-reverse))

;utf8 version (not same semantics!)
(define-inline (reverse-list->string chs)
  (list->string (reverse! chs)) )

(include "string-interpolation-body")

) ;utf8-string-interpolator
